/*
ͻ
  FILENAME : Actor.CPP                                    
  COMPILER : Turbo C++ Version 1.00                       
  INCLUDE  : Control.H, Graphic.H, Standard.H, Getkey.H   
           : Keyboard.H                                   
͹
  Present by MR.Watcharop   Riangrungrote (WRR)           
             Mechanical   Engineering                     
             Chulalongkorn University                     
ͼ
*/

#include <graphics.h>
#include <alloc.h>
#include <stdlib.h>
#include "graphic.h"
#include "standard.h"
#include "keyboard.h"
#include "path.h"
#include "actor.h"

#define DELAY_TIME_MOVE 3

ACTOR::ACTOR( int row, int col, PathAPP *MP )
{
	FloorSize = MP->GetSizeFloor();
	Map = MP;
	DatumX = DatumY = 6;
	MaxRow = MaxRow = 40;
	RemoveRow = CurRow = row;
	RemoveCol = CurCol = col;
	DelayTimeMove = DELAY_TIME_MOVE;
	DrawActor = CntStepWalk = Walking = 0;
	FullStepWalk = 3;
	FullStepSize = 12;
	StepSize = 4;     // FullStepSize = FullStepWalk * StepSize
}

ACTOR::ACTOR( PathAPP *MP )
{
	FloorSize = MP->GetSizeFloor();
	Map = MP;
	RanPos();
	DatumX = DatumY = 6;
	MaxRow = MaxRow = 40;
	RemoveRow = CurRow = RanRow;
	RemoveCol = CurCol = RanCol;
	DelayTimeMove = DELAY_TIME_MOVE;
	DrawActor = CntStepWalk = Walking = 0;
	FullStepWalk = 3;
	FullStepSize = 12;
	StepSize = 4;     // FullStepSize = FullStepWalk * StepSize
}

ACTOR::ACTOR( int FSWalk, PathAPP *MP )
{
	FloorSize = MP->GetSizeFloor();
	Map = MP;
	RanPos();
	DatumX = DatumY = 6;
	MaxRow = MaxRow = 40;
	RemoveRow = CurRow = RanRow;
	RemoveCol = CurCol = RanCol;
	DelayTimeMove = DELAY_TIME_MOVE;
	DrawActor = CntStepWalk = Walking = 0;

		// FullStepSize = FullStepWalk * StepSize
	FullStepWalk = FSWalk;
	FullStepSize = 12;
	StepSize = FullStepSize / FSWalk;
}


// Random Position
void ACTOR::RanPos( void )
{
	while( 1 )
	{
		RanRow = random( 40 );
		RanCol = random( 40 );
		if( Map->HaveFloor( RanRow, RanCol ) )
			break;
	}
}

// Random Position
void ACTOR::RanDistPos( int row, int col, int dist )
{
	RanPos();

	int RowMark, ColMark, DistMark;
	int Dist;
	DistMark = abs(row-RanRow) + abs(col-RanCol);
	if( DistMark >= dist )
		return;
	RowMark = RanRow;
	ColMark = RanCol;

	for( int i = 0 ; i < 5 ; i++ )
	{
		RanPos();
		Dist = abs(row-RanRow) + abs(col-RanCol);
		if( Dist >= dist )
			break;
		if( Dist > DistMark )
		{
			RowMark = RanRow;
			ColMark = RanCol;
		}

	}
	RanRow = RowMark;
	RanCol = ColMark;
}


void ACTOR::CalCurPos( void )
{
	CurX = DatumX + CurCol*FullStepSize;
	CurY = DatumY + CurRow*FullStepSize;

	BYTE OffsetWalk = CntStepWalk*StepSize;
	switch( Walking ) {
	case WALK_L :
		CurX -= OffsetWalk;
		break;
	case WALK_R :
		CurX += OffsetWalk;
		break;
	case WALK_Up :
		CurY -= OffsetWalk;
		break;
	case WALK_Dn :
		CurY += OffsetWalk;
		break;
	}
}

void ACTOR::GetCurPos( int *row, int *col )
{
	*row = CurRow;
	*col = CurCol;
}

void ACTOR::GetRemovePos( int *row, int *col )
{
	*row = RemoveRow;
	*col = RemoveCol;
}

void ACTOR::GetHoldPoint( int *HoldX, int *HoldY )
{
	*HoldX = CurX - 6;
	*HoldY = CurY - 6;
}

void ACTOR::GetCurPoint( int *X, int *Y )
{
	CalCurPos();
	*X = CurX;
	*Y = CurY;
}


void ACTOR::ChkActor( int row, int col )
{
	if( row == CurRow && col == CurCol )
	{
		DrawActor = 1;
		return;
	}
	if( row == RemoveRow && col == RemoveCol )
		DrawActor = 1;
}

