/*
ͻ
  FILENAME : Control.CPP                                  
  COMPILER : Turbo C++ Version 1.00                       
  INCLUDE  : Control.H, Graphic.H, Standard.H, Getkey.H   
           : Keyboard.H                                   
͹
  Present by MR.Watcharop   Riangrungrote (WRR)           
             Mechanical   Engineering                     
             Chulalongkorn University                     
ͼ
*/

#include <graphics.h>
#include <alloc.h>
#include "graphic.h"
#include "standard.h"
#include "keyboard.h"
#include "control.h"

//#define _GAME2_

#define DelayLoopDivide 3

DWORD BlinkTime = 10;
DWORD MoveDelayLoop;
int FirstMove;


ImaCtrl::ImaCtrl( int SX, int SY, int row, int col, int resX, int resY,
				  MapPtr Ima )
{
	int far *Size = (int far *)Ima;
	StartX = SX;
	StartY = SY;
	Row = row;
	Col = col;
	ResX = resX;
	ResY = resY;
	ImaShow = CurRow = CurCol = ImaActive = CtrlRun = 0;
	Image = Ima;
	SizeX = *Size++;
	SizeY = *Size;
	ImaPick = (MapPtr) farmalloc( imagesize(0,0,SizeX,SizeY) );
	SetButtonKeysMode();
	TestSpeed();
	CntLoopMove = 0;
	FirstMove = 1;
	MoveDelayLoop = _SpeedLoop/DelayLoopDivide;
}

void ImaCtrl::SwitchOn( void )
{
	if( CtrlRun )
		return;
	CtrlRun = !CtrlRun; // CtrlRun = 1
	GetImage();
	Active();
	TimeLastBlink = TIME;
}

void ImaCtrl::SwitchOff( void )
{
	if( !CtrlRun )
		return;
	CtrlRun = !CtrlRun; // == 0
	Restore();
}

WORD ImaCtrl::Run( void )
{
	WORD key;
	int row, col;

	if( !CtrlRun )
		return 0;
	WORD ChkKey = 0;

	col = CurCol;
	row = CurRow;

	if( GetKeyState(KEY_LEFT) )
	{
		col--;
		if( col < 0 )
			col = Col - 1;
		ChkKey |= 1;
	}
	if( GetKeyState(KEY_RIGHT) )
	{
		if( ChkKey )
			ChkKey |= 0X0100;
		col++;
		if( col >= Col )
			col = 0;
		ChkKey |= 2;
	}
	if( GetKeyState(KEY_UP) )
	{
		if( ChkKey )
			ChkKey |= 0X0100;
		row--;
		if( row < 0 )
			row = Row - 1;
		ChkKey |= 4;
	}
	if( GetKeyState(KEY_DOWN) )
	{
		if( ChkKey )
			ChkKey |= 0X0100;
		row++;
		if( row >= Row )
			row = 0;
		ChkKey |= 8;
	}

	if( ChkKey & 0X0100 )
		ChkKey = 0;

	if( ChkKey )
	{
		if( FirstMove == 1 )
		{
			NewRC( row, col );
			FirstMove = 2;
			return ChkKey;
		}
		else
		{
			if( CntLoopMove >= MoveDelayLoop )
			{
				if( FirstMove )
				{
					MoveDelayLoop /= 15;
					FirstMove = 0;
				}
				CntLoopMove = 0;
				NewRC( row, col );
				return ChkKey;
			}
			else
				CntLoopMove++;
		}

	}
	else
	{
		MoveDelayLoop = _SpeedLoop/DelayLoopDivide;
		FirstMove = 1;
	}

	Run_EndLABEL:
	TimeCtrl();
	return 0;
}

void ImaCtrl::GetRC( int *row, int *col )
{
	*row = CurRow;
	*col = CurCol;
}

void ImaCtrl::GetCenterXY( int *x, int *y )
{
	CalBorder();
	*x = Left + SizeX/2;
	*y = Top + SizeY/2;
}

void ImaCtrl::Restore( void )
{
	if( ImaActive )
	{
		putimage( Left, Top, ImaPick, COPY_PUT );
		ImaActive = !ImaActive;         // ImaActive == 0
	}
}

void ImaCtrl::Active( void )
{
	ImaActive = 1;
	PutImage( Left, Top, Image, NOBLACK );
}

void ImaCtrl::NewRC( int row, int col )
{
	Restore();    			// Restore image of the old picture
	CurRow = row;
	CurCol = col;
	GetImage();
	Active();
	TimeLastBlink = TIME;
}

void ImaCtrl::GetImage( void )
{
	CalBorder();
	getimage( Left, Top, Right, Bottom, ImaPick );
}

void ImaCtrl::CalBorder( void )
{
	Left = StartX + CurCol*ResX;
	Right = Left + SizeX;
	Top = StartY + CurRow*ResY;
	Bottom = Top + SizeY;
}

void ImaCtrl::TimeCtrl( void )
{
	DWORD t = TIME;
	if( t - TimeLastBlink >= BlinkTime )
	{
		TimeLastBlink = t;
		if( ImaActive )
			Restore();
		else
			Active();
	}
}

ImaCtrl::~ImaCtrl( void )
{
	SwitchOff();
	if( Image )
		farfree( Image );
	if( ImaPick )
		farfree( ImaPick );
	SetNormalKeysMode();
}