#if !defined(_EDIT_LINE_H_)
#define _EDIT_LINE_H_

#include "standard.h"
#include "graphic.h"
#include "getkey.h"
#include "cwfont.h"

typedef struct {
	int StartX, StartY;         // Start point of input dialogue
	int MaxLenShow;
	int C_Fore, C_Back, C_Highlight, C_Cursor;
	} EDITLineFormat;

#define MAX_CHAR_SHOW 50

class CURSORVer
{
	private :
		int DatumX, DatumY, CurOffset;
		int SaveX;
		BYTE C_Cursor;
		BYTE Working, NowDisp;
		BYTE ColorPick[3];  	// for save screen 20 pixels
		DWORD TimeLastChg;

    protected :
		BYTE C_Fore, C_Back;

		void Display( int OffsetX );
		void Store( int OffsetX );
		void Restore( void );

	public :
		CURSORVer( EDITLineFormat *Format );
		void TimeControl( void );
		void CursorOn( void );
		void CursorOff( void );
		void GotoOffset( int OffsetX );
};


class EDITLine : public CURSORVer
{
	private :
		BYTE TabOption, FirstInput;
		BYTE *StrEdit;
		BYTE C_Highlight;
		BYTE Language;

		int MaxStrSize, MaxLenShow;
		int NumChar, CurStrPos, FirstStrShow;
		int StartX, StartY, Width, Heigth;
		int TEditX, TEditY;

		BYTE StrShow[MAX_CHAR_SHOW];

		void Write( void );
		void HighlightText( void );
		int DelChar( int Position );
		void ClearEditArea( void );
		int InsertChar( unsigned char ch );

	public :
		EDITLine( EDITLineFormat *Format, int MaxStr, BYTE *String );
		inline void SetTabOption( BYTE Option )
		{ TabOption = Option; }
		inline void SetLanguage( BYTE language )
		{ Language = language; }

		virtual void Set( void );
		virtual void Unset( void );
		virtual int Input( void );
		virtual void SetString( BYTE *Str );
};

#endif
