#include <graphics.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include <alloc.h>
#include <time.h>
#include <ctype.h>
#include "graphic.h"
#include "standard.h"
#include "manager.h"
#include "getkey.h"
#include "keyboard.h"
#include "border.h"

char MapFilename[80];

char MarkTextTotal[] = "Total Stage";
int TotalStage = 12;

char ContinueText[] =
	 "$1Do you want to continue KALYANAMITRA GAME ?\n($EY$1es/$EN$1o)";

MANAGER *Game;
MapPtr MarkIma = NULL;

void ScreenView( void )
{
	setfillstyle( SOLID_FILL, CYAN );
	bar( 0, 0, 479, 479 );
	setfillstyle( SOLID_FILL, RED );
	bar( 480, 0, 639, 479 );
}


void InitialGame( int Stage )
{
	char FileMap[20];
	if( MapFilename[0] != 0 )
		strcpy( FileMap, MapFilename );
	else
		sprintf( FileMap,"STAGE%02d.MAP", Stage );
	setfillstyle( SOLID_FILL, BLACK );
	bar( 0, 0, 479, 479 );
	setfillstyle( SOLID_FILL, RED );
	bar( 480, 0, 639, 479 );
	Game = new MANAGER( FileMap );
}

int RetCode;
//  0 	GAME CONTINUE
//  2   PLAYER Cancel
//	1   GAME END : Found Final Point
// -1 	GAME OVER : Out of time
// -2	GAME OVER : Small Radius < 10

void EndGame( void )
{
	if( MarkIma )
		farfree( MarkIma );
	closegraph();
}


int GameContinueYN()
{
	BORDER ConBor1 = { 130, 180, 510, 290 };
	BORDER ConBor1In = { 140, 190, 500, 280 };

	BDFillIn( &ConBor1, LIGHTGRAY, BLUE );
	BORDER_COLOR = LIGHTGRAY;
	BDLine( &ConBor1In, 0, 2 );
	if( MarkIma )
		putimage( 150, 200, MarkIma, COPY_PUT );

	settextstyle( DEFAULT_FONT, HORIZ_DIR, 1 );
	settextjustify( LEFT_TEXT, TOP_TEXT );
	Gprintf( 150 , 245, ContinueText );

	/*
	KEY Key;
	char ch = 0;
	do {
		Key.Key = getkeyw();
		Key.Extend.Ascii = tolower( Key.Extend.Ascii );
	} while( Key.Extend.Ascii != 'y' && Key.Extend.Ascii != 'n' );

	if( Key.Extend.Ascii == 'y' )
		return 1;
	return 0;
	*/

	KEY Key;
	GETKEY_FLAG = 1;
	BYTE ch;
	do {
		Key.Key = getkeyw();
		ch = Key.Extend.Ascii;
	} while( ch != 'Y' && ch != 'y' && ch != 'N' && ch != 'n' );
	GETKEY_FLAG = 0;
	if( ch == 'Y' || ch == 'y' )
		return 1;
	return 0;

}

void RunTitle( void )
{
	BORDER TitleBor = { 100, 50, 540, 430 };
	BORDER_COLOR = RED;
	BDDraw( &TitleBor, 1, 5 );
	setcolor( RED );
	rectangle( 99, 49, 541, 431 );

	if( MarkIma )
		putimage( 300, 70, MarkIma, COPY_PUT );

	settextstyle( TRIPLEX_FONT, HORIZ_DIR, 3 );
	settextjustify( CENTER_TEXT, CENTER_TEXT );
	setcolor( LIGHTRED );
	setusercharsize( 4, 5, 4, 5 );
	outtextxy( 320, 120, "Children's Creative" );
	outtextxy( 320, 150, "Development Training Project" );

	settextstyle( DEFAULT_FONT, HORIZ_DIR, 1 );
	settextjustify( CENTER_TEXT, TOP_TEXT );
	setcolor( RED );
	outtextxy( 320, 200, "Dhammakaya Foundation" );
	outtextxy( 320, 220, "Dhammakaya International Meditation Center" );

	settextjustify( LEFT_TEXT, BOTTOM_TEXT );
	Gprintf( 130, 380, "$1Conceptual Design : $9Orasa  Suksawang" );
	Gprintf( 130, 400, "$1Program           : $9Watcharop  Riangrungrote" );
}

void RunGame( void )
{
	int stage, index;

	ImaReadFile( &MarkIma, "Mark.IMA" );
	StartGraphics();

	RunTitle();
	getkeyw();
	setbkcolor( BLACK );

	BeginModule :
	stage = random( TotalStage ) + 1;
	InitialGame( stage );
	RetCode = Game->Run();
	Game->EndTitle( RetCode );
	delete Game;
	ScreenView();
	if( GameContinueYN() )
		goto BeginModule;
	SetNormalKeysMode();
}

void main( int argc, char *argv[] )
{
	if( argc > 1 )
	{
		FILE *fptr;
		strcpy( MapFilename, argv[1] );
		fptr = fopen( MapFilename, "rt" );
		if( !fptr )
		{
			printf("File %s not found.\n", MapFilename );
			return;
		}
		fclose( fptr );
	}
	else
	{
		strcpy( MapFilename, "" );
	}

	TestSpeed();
	randomize();

	registerfarbgifont( triplex_font_far );

	RunGame();
	EndGame();
}
