#include <stdio.h>
#include <graphics.h>
#include <stdlib.h>
#include "graphic.h"
#include "standard.h"
#include "border.h"
#include "gametime.h"

// TIME 18.2 = 1 second

#define TIME_COUNT_DOWN 1
#define TIME_DELAY 42

#define TIME_DELAY_MSG 150

static BORDER TimeBor1 = { 490, 35, 630, 120 };
static BORDER TimeBor1_1 = { 500, 45, 620, 65 };
static BORDER TimeBor1_2 = { 500, 75, 620, 110 };

#define TIME_CEN_X 560
#define TIME_CEN_Y 93

static BORDER RadBor1 = { 490, 140, 630, 200 };
#define RAD_RIGHT_X 600
#define RAD_CEN_Y 170

GAMETIME::GAMETIME( void )
{
	char HeadText[] = "Remaining Time";
	BackColor = YELLOW;
	TimeColor = LIGHTBLUE;

	FLOOR_COLOR = LIGHTGRAY;
	BORDER_COLOR = BLUE;
	BDDraw( &TimeBor1, 1, 3 );
	BDFillIn( &TimeBor1_1, WHITE, BLUE );

	settextstyle( DEFAULT_FONT, HORIZ_DIR, 1 );
	settextjustify( CENTER_TEXT, CENTER_TEXT );
	outtextxy( 560, 55, HeadText );

	TimeRemain = 75;
	TimeMessage = TimeLastChg = TIME;
	WriteTime();
}

// return -1 if Out of time
int GAMETIME::RunTime( void )
{
	DWORD t = TIME;
	if( t - TimeLastChg >= TIME_DELAY )
	{
		TimeLastChg = t;
		TimeRemain -= TIME_COUNT_DOWN;
		if( TimeRemain < 10 )
			TimeColor = LIGHTRED;
		WriteTime();
		if( TimeRemain <= 0 )
			return -1;
		if( TimeRemain == 9 )
			return 21 + random( 2 );
	}

	if( t - TimeMessage >= TIME_DELAY_MSG )
	{
		TimeMessage = t;
		return 23 + random( 5 );
	}
	return 0;
}

void GAMETIME::ResetTimeMsg( void )
{
	TimeMessage = TIME;
}

char DigitText[5];

void GAMETIME::WriteTime( void )
{
	ClearCntTimeArea();
	settextstyle( TRIPLEX_FONT, HORIZ_DIR, 2 );
	settextjustify( CENTER_TEXT, CENTER_TEXT );
	setcolor( TimeColor );
	sprintf( DigitText, "%02d", TimeRemain );
	outtextxy( TIME_CEN_X, TIME_CEN_Y, DigitText );
}

void GAMETIME::WriteRadius( int Rad )
{
	if( Rad < 0 )
		Rad = 0;
	if( Rad >= 25 )
	{
		BDFillIn( &RadBor1, WHITE, BLUE );
		setcolor( BLUE );
	}
	else
	{
		BDFillIn( &RadBor1, LIGHTGREEN, BLUE );
		setcolor( BLACK );
	}
	settextstyle( TRIPLEX_FONT, HORIZ_DIR, 2 );
	settextjustify( RIGHT_TEXT, CENTER_TEXT );
	sprintf( DigitText, "%3d", Rad );
	outtextxy( RAD_RIGHT_X, RAD_CEN_Y, DigitText );
}

void GAMETIME::ClearCntTimeArea( void )
{
	FLOOR_COLOR = BackColor;
	BORDER_COLOR = BLUE;
	BDDraw( &TimeBor1_2, 0, 2 );
}
