
//
//  FILENAME : GetKey.C
//  COMPILER : Turbo C++ Version 1.00
//  INCLUDE  : GetKey.H, Standard.H
//
//  Present by MR.Watcharop   Riangrungrote (WRR)
//             Mechanical   Engineering
//             Chulalongkorn University
//


#include "getkey.h"
#include "standard.h"

unsigned int far *HeadKey=(unsigned int far *)0X40001AL;
unsigned int far *TailKey=(unsigned int far *)0X40001CL;
const unsigned int far *_KeyBuffer = (unsigned int far *)0X40001EL;
const unsigned int far *_KeyFlag = (unsigned int far*)0X400017L;

unsigned char _ThaiEngMode = ENG;
int _ModeToggle = 0;

const unsigned char _ThaiTable[128] = {
	0X00, 0X01, 0X02, 0X03, 0X04, 0X05, 0X06, 0X07,		/*== 00 ==*/
	0X08, 0X09, 0X0A, 0X0B, 0X0C, 0X0D, 0X0E, 0X0F,
	0X10, 0X11, 0X12, 0X13, 0X14, 0X15, 0X16, 0X17,     /*== 10 ==*/
	0X18, 0X19, 0X1A, 0X1B, 0X1C, 0X1D, 0X1E, 0X1F,
	0X20, 0XED, 0X2E, 0XF2, 0XF3, 0XF4, 0XDB, 0XA7,     /*== 20 ==*/
	0XF6, 0XF7, 0XF5, 0XF9, 0XC1, 0XA2, 0XE3, 0XBD,
	0XA8, 0XE5, 0X2F, 0X5F, 0XC0, 0XB6, 0XD8, 0XD6,     /*== 30 ==*/
	0XA4, 0XB5, 0XAB, 0XC7, 0XB2, 0XAA, 0XCC, 0XC6,
	0XF1, 0XC4, 0XDA, 0XA9, 0XAF, 0XAE, 0XE2, 0XAC,     /*== 40 ==*/
	0XE7, 0XB3, 0XEB, 0XC9, 0XC8, 0X3F, 0XEC, 0XCF,
	0XAD, 0XF0, 0XB1, 0XA6, 0XB8, 0XEA, 0XCE, 0X22,     /*== 50 ==*/
	0X29, 0XEB, 0X28, 0XBA, 0XA3, 0XC5, 0XD9, 0XF8,
	0X2B, 0XBF, 0XD4, 0XE1, 0XA1, 0XD3, 0XB4, 0XE0,     /*== 60 ==*/
	0XE9, 0XC3, 0XE8, 0XD2, 0XCA, 0XB7, 0XD7, 0XB9,
	0XC2, 0XE6, 0XBE, 0XCB, 0XD0, 0XD5, 0XCD, 0XE4,     /*== 70 ==*/
	0XBB, 0XD1, 0XBC, 0XB0, 0XA5, 0X2C, 0X25, 0X7F
};


// Wait for key press
unsigned int getkeyw( void )
{
	while( *HeadKey == *TailKey );
	return getkey();
}

unsigned int getkeywOnly( void )
{
	while( *HeadKey == *TailKey );
	return getkeyOnly();
}

unsigned int getkeyOnly( void )
{
	if( *HeadKey == *TailKey )
		return 0;
	return (_KeyBuffer[(*HeadKey-0X1E)/2]); 	/* get key from buffer */
}

void clrkeyAll( void )
{
	*HeadKey = *TailKey;
}

void clrkeyOne( void )
{
	if( *HeadKey != *TailKey )
	{
		*HeadKey += 2;
		if( *HeadKey > 0X3D )
			*HeadKey = 0X1E;
	}
}

void ClrkeyOne( void )
{
	static unsigned int HeadKeyChk = 0;
	if( *HeadKey != *TailKey )
	{
		if( *HeadKey == HeadKeyChk )
		{
			*HeadKey += 2;
			if( *HeadKey > 0X3D )
				*HeadKey = 0X1E;
		}
		else
			HeadKeyChk = *HeadKey;
	}
}


// Not wait for keypress and return 0 if key buffer is empty
unsigned int  getkey( void )
{
	int Key;

	if( *HeadKey == *TailKey )
		return 0;

	Key = getkeyOnly();
	clrkeyOne();

	return Key;
}

unsigned int getthaikey( void )
{
	KEY Key;
	Key.Key = getkey();

	if( Key.Key == _ModeToggle && _ModeToggle )
	{
		_ThaiEngMode = !_ThaiEngMode;
		return Key.Key;
	}

	if( _ThaiEngMode && (Key.Extend.ScanCode<=0X36) )
		Key.Extend.Ascii = _ThaiTable[Key.Extend.Ascii];

	return Key.Key;
}

unsigned char Eng2Thai( unsigned int key )
{
	KEY Key;
	Key.Key = key;
	if( Key.Extend.ScanCode <= 0X36 )
		return _ThaiTable[Key.Extend.Ascii];
	return Key.Extend.Ascii;
}

unsigned char Eng2Thai( KEY *Key )
{
	if( Key->Extend.ScanCode <= 0X36 )
		return _ThaiTable[Key->Extend.Ascii];
	return Key->Extend.Ascii;
}


inline void SetToggleModeKey( int Key )
{
	_ModeToggle = Key;
}

inline unsigned char GetModeKey( void )
{
	return _ThaiEngMode;
}

inline void SetModeKey( int mode )
{
	_ThaiEngMode = mode;
}
