#include <graphics.h>
#include "grid.h"

GridAPP::GridAPP( int SX, int SY, int row, int col, int width, int heigth,
				  int Back, int Fore )
{
	Width = width;
	Heigth = heigth;
	Row = row;
	Col = col;
	Left = SX;
	Top = SY;
	Right = Left + Col*Width;
	Bottom = Top + Row*Heigth;
	C_Back = Back;
	C_Fore = Fore;
}

void GridAPP::Draw( void )
{
	setcolor( C_Fore );
	rectangle( Left, Top, Right, Bottom );

	/*===== line vertical =====*/
	for( int index = Left ; index < Right ; index += Width )
		line( index, Top, index, Bottom );

	/*===== line horizontal =====*/
	for( index = Top ; index < Bottom ; index += Heigth )
		line( Left, index, Right, index );
}

void GridAPP::Fill( void )
{
	setfillstyle( SOLID_FILL, C_Back );
	setcolor( C_Fore );
	bar( Left, Top, Right, Bottom );
	rectangle( Left, Top, Right, Bottom );

	/*===== line vertical =====*/
	for( int index = Left ; index < Right ; index += Width )
		line( index, Top, index, Bottom );

	/*===== line horizontal =====*/
	for( index = Top ; index < Bottom ; index += Heigth )
		line( Left, index, Right, index );
}

void GridAPP::FillRC( int row, int col )
{
	int x1 = Left + col*Width;
	int y1 = Top + row*Heigth;
	int x2 = x1 + Width;
	int y2 = y1 + Heigth;
	setfillstyle( SOLID_FILL, C_Back );
	setcolor( C_Fore );
	bar( x1, y1, x2, y2 );
	rectangle( x1, y1, x2, y2 );
}

void GridAPP::FillRC( int row, int col, int color )
{
	int x1 = Left + col*Width;
	int y1 = Top + row*Heigth;
	int x2 = x1 + Width;
	int y2 = y1 + Heigth;
	setfillstyle( SOLID_FILL, color );
	setcolor( C_Fore );
	bar( x1, y1, x2, y2 );
	rectangle( x1, y1, x2, y2 );
}
