#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>
#include <string.h>
#include <alloc.h>
#include <ctype.h>
#include "graphic.h"
#include "getkey.h"
#include "standard.h"
#include "grid.h"
#include "control.h"
#include "image.h"

#define BLOCK_WH 10

void DrawIma( void );
void InitialProgram( void );
void RunProgram( void );
void EndProgram( void );


unsigned char EDITFile;  //   EDITFile == 1 for edit old file
char filename[40];

MapPtr Box;
MapPtr Picture = NULL;
int PixelX = -1, PixelY = -1;
int PicX, PicY;

void ImageBox( void );

void main( int argc, char *argv[] )
{
	if( argc < 2 )
	{
		printf("Usage : IMAGE filename \n");
		abort();
	}
	strcpy( filename, argv[1] );
	if( !ImaReadFile( &Picture, argv[1] ) )
	{
		printf("Input pixel x : ");
		scanf("%d", &PixelX );
		if( PixelX <= 0 )
			abort();
		printf("Input pixel y : ");
		scanf("%d", &PixelY );
		if( PixelY <= 0 )
			abort();
	}
	else
		if( !Picture )
			abort();
	InitialProgram();
	RunProgram();
	EndProgram();
}


void InitialProgram( void )
{
	StartGraphics();
	if( Picture )
	{
		int far *IntPtr = (int far *)Picture;
		PixelX = *IntPtr++;
		PixelY = *IntPtr;
		PixelX++;
		PixelY++;
	}
	else
	{
		size_t size = imagesize( 1, 1, PixelX, PixelY );
		Picture = (MapPtr) farmalloc( size );
		getimage( 1, 1, PixelX, PixelY, Picture );
	}
	ImageBox();
	cleardevice();

	for( int j = 0 ; j < 4 ; j++ )
	{
		int y, i;
		for( i = 0 ; i < 4 ; i++ )
		{
			y = 100*j + 20*i;
			setfillstyle( SOLID_FILL, 4*j+i );
			bar( 600, y, 639, y+20 );
		}
	}
}

void RunProgram( void )
{
	unsigned int key;
	ImageAPP ImaApp( (void far *)Picture );
	GridAPP Grid( 0, 0, PixelY, PixelX, BLOCK_WH, BLOCK_WH, WHITE, BLUE );
	DrawIma();
	ImaCtrl BoxCtrl( 0, 0, PixelY, PixelX, BLOCK_WH, BLOCK_WH, Box );
	BoxCtrl.SwitchOn();
	WORD color = 0;
	do {
		BoxCtrl.Run();
		key = getkeyOnly();
		WORD color1 = key & 0X00FF;
		if( isdigit( color1 ) )
			color = color1 - '0';
		else if( islower( color1 ) )
		{
			if( color1 <= 'f' )
				color = color1 - 'a' + 10;
		}
		else if( isupper( color1 ) )
		{
			if( color1 <= 'F' )
				color = color1 - 'A' + 10;
		}

		if( KeyFlag & LCtrl )
		{
			int px, py;
			BoxCtrl.GetRC( &py, &px );
			int getc1 = ImaApp.GetPixel(px,py);
			if( getc1 != color )
			{
				BoxCtrl.SwitchOff();
				ImaApp.Plot( px, py, color );
				Grid.FillRC( py, px, color );
				putimage( PicX, PicY, Picture, COPY_PUT );
				BoxCtrl.SwitchOn();
			}
		}
		if( key == 0X3B00 )
		{
			if( !ImaWriteFile( Picture, filename ) )
			{
				EndProgram();
				printf(" Can not write file.\n");
			}
		}
		clrkeyOne();
	} while( key != Esc );
}


void DrawIma( void )
{
	GridAPP G( 0, 0, PixelY, PixelX, BLOCK_WH, BLOCK_WH, WHITE, BLUE );
	ImageAPP ImaRun( (void far *)Picture );
	for( int j = 0 ; j < PixelY ; j++ )
	{
		int i;
		for( i = 0 ; i < PixelX ; i++ )
			G.FillRC( j, i, ImaRun.GetPixel(i,j) );
	}
	PicX = 580 - PixelX;
	PicY = 450 - PixelY;
	putimage( PicX, PicY, Picture, COPY_PUT );
}



void ImageBox( void )
{
	size_t size;

	setcolor( YELLOW );
	rectangle( 0, 0, BLOCK_WH, BLOCK_WH );
	rectangle( 1, 1, BLOCK_WH-1, BLOCK_WH-1 );
	size = imagesize( 0, 0, BLOCK_WH, BLOCK_WH );
	Box = (MapPtr) farmalloc( size );
	getimage( 0, 0, BLOCK_WH, BLOCK_WH, Box );
}

void EndProgram( void )
{
	closegraph();
}

