#include <graphics.h>
#include <dos.h>
#include <stdlib.h>
#include <alloc.h>
#include "keyboard.h"
#include "graphic.h"
#include "manager.h"
#include "getkey.h"

#define DEATH_RADIUS 10
extern MapPtr MarkIma;

void SoundGood( void )
{
	unsigned int Freq = 500;
	for( ; Freq < 4000 ; Freq += 100 )
	{
		sound( Freq );
		delay( 10 );
	}
	nosound();
}

void SoundBad( void )
{
	unsigned int Freq = 40;
	for( ; Freq < 500 ; Freq += 15 )
	{
		sound( Freq );
		delay( 8 );
	}
	nosound();
}


MANAGER::MANAGER( char *FileStage ) :
GAMETIME()
{
	int row, col;
	int X, Y;

	MapMAIN = new PathAPP( FileStage );		// Initial PathAPP
//	MapMAIN->RandomFinal();
	MsgMAIN = NULL;							// Set MsgMAIN
	ImaReadFile( &WarnIma, "Warning.IMA" );

	Actor1 = new ACTOR1( MapMAIN );			// Initial ACTOR1
	Actor1->GetCurPos( &row, &col );

	// Initial ACTOR2
	for( register int NumAct2 = 0 ; NumAct2 < MAX_ACTOR2 ; NumAct2++ )
		Actor2[NumAct2] = new ACTOR2( !(NumAct2/GOOD_ACTOR),
									  row, col, MapMAIN );

	StartRadius = Actor1->GetRadius();
	MapMAIN->GetFinal( &FinalR, &FinalC );
	Actor1->Vision();

	Actor1->GetCurPoint( &X, &Y );
	StartRadius = Actor1->GetRadius();
	WriteRadius( StartRadius );

	if( StartRadius >= 25 )
		MsgMAIN = new MESSAGE( X, Y, StartRadius, 20 );
	else
		MsgMAIN = new MESSAGE( X, Y, StartRadius, 19 );
}

// Return
//  0 	GAME CONTINUE
//  2   PLAYER Cancel
//	1   GAME END : Found Final Point
// -1 	GAME OVER : Out of time
// -2	GAME OVER : Small Radius < 10
int MANAGER::Run( void )
{
	int row, col;
	int X, Y;
	int RadWarn = 0;

	BeginModule :

	for( register int i = 0 ; i < MAX_ACTOR2 ; i++ )
		if( Actor2[i] )
			Actor2[i]->Run();
	Actor1->Run();
	int ChkState = ChkActPos();
	if( ChkState >= 0 )
	{
		int DeltaRad = Actor2[ChkState]->GetDeltaRadius();
		if( ChkState < GOOD_ACTOR )
		{
			Actor1->IncRadius( DeltaRad );
			SoundGood();
		}
		else
		{
			Actor1->DecRadius( DeltaRad );
			SoundBad();
		}

		int Rad = Actor1->GetRadius();
		WriteRadius( Rad );
		if( Rad < DEATH_RADIUS )
			return -2;

		Actor2[ChkState]->SetNewPosition( row, col, 20 );
		if( Rad < 25 )
		{
			if( !RadWarn )
			{
				RadWarn = 1;
				Actor1->GetCurPos( &row, &col );
				if( MsgMAIN )
					delete MsgMAIN;
				Actor1->GetCurPoint( &X, &Y );
				ResetTimeMsg();
				MsgMAIN = new MESSAGE( X, Y, Actor1->GetRadius(),
									   28 + random(2) );
				goto EndIF;
			}
		}
		else
			RadWarn = 0;


		Actor1->GetCurPos( &row, &col );
		if( MsgMAIN )
			delete MsgMAIN;
		Actor1->GetCurPoint( &X, &Y );
		ResetTimeMsg();
		MsgMAIN = new MESSAGE( X, Y, Actor1->GetRadius(),
									 (int)Actor2[ChkState]->GetMessage() );
	}
	EndIF :

	if( MsgMAIN )
	{
		Actor1->GetCurPoint( &X, &Y );
		if( !MsgMAIN->Run( X, Y ) )
		{
			delete MsgMAIN;
			MsgMAIN = NULL;
		}
	}

	if( ChkFinal() )
	{
		if( MsgMAIN )
		{
			delete MsgMAIN;
			MsgMAIN = NULL;
		}
		MapMAIN->DrawMap();
		WriteRadius( 999 );
		delay( 1000 );
		return 1;		// Found Final Point
	}

	int TimeChk = RunTime();
	switch( TimeChk ) {
	case -1 :
		return -1;  // Out of time
	default :
		if( TimeChk )
		{
			if( MsgMAIN )
				delete MsgMAIN;
			ResetTimeMsg();
			Actor1->GetCurPoint( &X, &Y );
			MsgMAIN = new MESSAGE( X, Y, Actor1->GetRadius(), TimeChk );
		}
	}

	if( GetKeyState(KEY_ESC) )
	{
		if( QuitYN() )
			return 2;		// Player cancel
	}

	goto BeginModule;
}

// return -1 Actor1 not found Actor2
// or return Number of Actor2 that found
int MANAGER::ChkActPos( void )
{
	int Act1X, Act1Y;
	int Act2X, Act2Y;
	int dist;
	Actor1->GetCurPoint( &Act1X, &Act1Y );

	for( int NumAct2 = 0 ; NumAct2 < MAX_ACTOR2 ; NumAct2++ )
	{
		if( Actor2[NumAct2] )
		{
			Actor2[NumAct2]->GetCurPoint( &Act2X, &Act2Y );
			dist = abs( Act2X - Act1X );
			dist += abs( Act2Y - Act1Y );
			if( dist < 4 )
				return NumAct2;
		}
	}
	return -1;
}

// return 1 if found final point
int MANAGER::ChkFinal( void )
{
	int Act1R, Act1C;
	Actor1->GetCurPos( &Act1R, &Act1C );
	if( Act1R == FinalR && Act1C == FinalC )
		return 1;
	return 0;
}

int MANAGER::QuitYN( void )
{
	BORDER QuitBorder = { 130, 180, 510, 290 };
	BORDER InBorder = { 140, 190, 500, 280 };

	size_t SizeBorder = imagesize( QuitBorder.Left, QuitBorder.Top,
								   QuitBorder.Right, QuitBorder.Bottom );
	MapPtr Pick = (MapPtr) farmalloc( SizeBorder );
	getimage( QuitBorder.Left, QuitBorder.Top,
			  QuitBorder.Right, QuitBorder.Bottom, Pick );
	BDFillIn( &QuitBorder, LIGHTGRAY, BLUE );
	BORDER_COLOR = LIGHTGRAY;
	BDLine( &InBorder, 0, 2 );
	if( WarnIma )
		putimage( 150, 200, WarnIma, COPY_PUT );

	settextstyle( DEFAULT_FONT, HORIZ_DIR, 1 );
	settextjustify( LEFT_TEXT, TOP_TEXT );
	Gprintf( 150, 245,
			 "$1Do you want to exit KALYANAMITRA Game now ?\n($EY$1es/$EN$1o)" );

	GETKEY_FLAG = 1;
	KEY Key;
	BYTE ch;
	do {
		Key.Key = getkeyw();
		ch = Key.Extend.Ascii;
	} while( ch != 'Y' && ch != 'y' && ch != 'N' && ch != 'n' );
	GETKEY_FLAG = 0;
	putimage( QuitBorder.Left, QuitBorder.Top, Pick, COPY_PUT );
	farfree( Pick );
	if( ch == 'Y' || ch == 'y' )
		return 1;
	return 0;
}

// Return
//  0 	GAME CONTINUE
//  2   PLAYER Cancel
//	1   GAME END : Found Final Point
// -1 	GAME OVER : Out of time
// -2	GAME OVER : Small Radius < 10
void MANAGER::EndTitle( int EndCode )
{
	char *EndText[] = {
		"$1Come with the $0darkness$1,  $1gone with the $0darkness$1.",
		"$1Come with the $0darkness$1,  $1gone with the $Flight$1.",
		"$1Come with the $Flight$1,  $1gone with the $0darkness$1.",
		"$1Come with the $Flight$1,  $1gone with the $Flight$1.",
		};

	if( MsgMAIN )
	{
		delete MsgMAIN;
		MsgMAIN = NULL;
	}

	settextstyle( DEFAULT_FONT, HORIZ_DIR, 1 );
	settextjustify( LEFT_TEXT, TOP_TEXT );
	setfillstyle( SOLID_FILL, RED );
	bar( 480, 200, 639, 479 );
	setfillstyle( SOLID_FILL, CYAN );
	bar( 0, 0, 479, 479 );

	int EndTextNum = 0;
	if( StartRadius >= 25 )
		EndTextNum = 2;

	if( EndCode != 2 )
	{
		switch( EndCode ) {
		case -1 : // Out of time
			int EndRadius = Actor1->GetRadius();
			if( EndRadius > StartRadius )
				EndTextNum++;
			break;

		case 1 : // Found Final
			EndTextNum++;
			break;
		}

		BORDER EndTitleBor1 = { 20, 50, 460, 250 };
		BORDER EndTitleBor1_1 = { 30, 60, 450, 205 };
		BORDER EndTitleBor1_2 = { 30, 220, 450, 240 };

		BDFillIn( &EndTitleBor1, LIGHTGRAY, BLUE );
		BORDER_COLOR = LIGHTGRAY;
		BDLine( &EndTitleBor1_1, 0, 2 );
		BDLine( &EndTitleBor1_2, 0, 2 );

		if( MarkIma )
			putimage( 40, 65, MarkIma, COPY_PUT );
		setcolor( BLUE );
		Gprintf( 40, 110,
			"There are four types of people," );
		Gprintf( 40, 135,
			"1. Come with the light, gone with the light." );
		Gprintf( 40, 150,
			"2. Come with the light, gone with the darkness." );
		Gprintf( 40, 165,
			"3. Come with the darkness, gone with the light." );
		Gprintf( 40, 180,
			"4. Come with the darkness, gone with the darkness." );

		Gprintf( 40, 209, "For you :" );
		Gprintf( 40, 226, EndText[EndTextNum] );

		clrkeyAll();
		GETKEY_FLAG = 1;
		int key;
		do {
			key = getkeyw();
		} while( key != Esc && key != Enter );
		GETKEY_FLAG = 0;
	}
}

MANAGER::~MANAGER( void )
{
	if( Actor1 )
		delete Actor1;
	if( MapMAIN )
		delete MapMAIN;
	for( register int i = 0 ; i < MAX_ACTOR2 ; i++ )
		delete Actor2[i];
	if( MsgMAIN )
		delete MsgMAIN;
	if( WarnIma );
		farfree( WarnIma );
}
