/*
ͻ
  FILENAME : Map.CPP                                      
  COMPILER : Turbo C++ Version 1.00                       
  INCLUDE  : Control.H, Graphic.H, Standard.H, Getkey.H   
͹
  Present by MR.Watcharop   Riangrungrote (WRR)           
             Mechanical   Engineering                     
             Chulalongkorn University                     
ͼ
*/

#include <graphics.h>
#include <alloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "graphic.h"
#include "standard.h"
#include "getkey.h"
#include "control.h"
#include "position.h"
#include "mappath.h"
#include "input.h"
#include "border.h"
#include "cwfont.h"


ImaCtrl *BoxCtrl = (ImaCtrl *) NULL;
MapPtr BoxIma = (MapPtr) NULL;


int InitialProgram( void )
{
	StartGraphics();
	CWDrv = new CWFONT( "Normal.FON" );
	if( !CWDrv )
		return 0;
	BoxIma = (MapPtr) farmalloc( imagesize(0,0,11,11) );
	if( !BoxIma )
		return 0;
	setcolor( WHITE );
	rectangle( 1, 1, 10, 10 );
	rectangle( 0, 0, 11, 11 );
	getimage( 0, 0, 11, 11, BoxIma );
	cleardevice();

	return 1;
}

char *HelpText[] = {
	"\t\t$4ԸҧἹ\n$",
	"1. ͧ $2$ ¡  ҧἹ\n  ͹\n",
	"2. ͹¡á١\n",
	"3. ҵͧҧ鹷ҧ顴 $2Ctrl\n",
	"4. ҵͧź鹷ҧ顴 $2Shift\n",
	"5. ˹觷 ͡ $2'f'$ 繡/ź\n  ˹觨ش»·ҧ\n",
	"6.  $2F2$ ͵ͧ Save Ἱ\n",
	"7.  $2Esc$ ͵ͧ͡ҡҧἹ\n",
	"8.  $2F3$ ͵ͧԴ File Ἱ͵ͧ\n  ҧ File Ἱ\n"
	};

/*
char *HelpText[] = {
	"\t\t$4ԸҧἹ\n$",
	"1. ͧ $2$ ¡  ҧἹ\n  ͹\n",
	"2. ͹¡á١\n",
	"3. ҵͧҧ鹷ҧ顴 $2Ctrl\n",
	"4. ҵͧź鹷ҧ顴 $2Shift\n",
	"5. ˹觷 ͡ $2'f'$ 繡/ź\n  ˹觨ش»·ҧ\n",
	"6.  $2F2$ ͵ͧ Save Ἱ\n",
	"7.  $2Esc$ ͵ͧ͡ҡҧἹ\n",
	"8.  $2F3$ ͵ͧԴ File Ἱ͵ͧ\n  ҧ File Ἱ\n"
	};
*/

void HelpView( void )
{
	BORDER HelpBor = { 165, 80, 475, 380 };
	size_t Size = imagesize( HelpBor.Left, HelpBor.Top,
							 HelpBor.Right, HelpBor.Bottom );
	MapPtr HelpPick = (MapPtr) farmalloc( Size );
	if( !HelpPick )
	{
		clrkeyOne();
		return;
	}
	getimage( HelpBor.Left, HelpBor.Top,
			  HelpBor.Right, HelpBor.Bottom, HelpPick );
	BORDER_COLOR = LIGHTBLUE;
	BDFillIn( &HelpBor, WHITE, LIGHTBLUE );
	BDLayOut( &HelpBor, LIGHTCYAN, 4 );

	CWDrv->SetColor( BLUE );
	CWDrv->ThaiTextXY( HelpBor.Left+12, HelpBor.Top+18,
					   (BYTE *)HelpText[0] );
	for( int index = 1 ; index < 9 ; index++ )
		CWDrv->ThaiText( (BYTE *)HelpText[index] );

	clrkeyAll();
	getkeyw();
	putimage( HelpBor.Left, HelpBor.Top, HelpPick, COPY_PUT );
	farfree( HelpPick );
	clrkeyAll();
}

MapPath *SetMapPath( char *filename )
{
	// Change extension
	char FileName[100];
	strcpy( FileName, filename );
	char *StrPtr = strchr( FileName, '.' );
	if( !StrPtr )
	{
		StrPtr = FileName + strlen( FileName );
		*StrPtr = '.';
	}
	StrPtr++;
	strcpy( StrPtr, "MAP" );

	static MapPath *MapPathMem;
	MapPathMem = new MapPath( FileName );
	if( MapPathMem )
	{
		if( MapPathMem->GetComplete() )
			return MapPathMem;
		delete MapPathMem;
		MapPtr FloorIma;
		ImaReadFile( &FloorIma, "Floor.IMA" );
		if( FloorIma )
		{
			MapPathMem = new MapPath( FileName, FloorIma );
			if( MapPathMem )
				return MapPathMem;
			farfree( FloorIma );
		}
	}
	return (MapPath *) NULL;
}


MapPath *MapMAIN = (MapPath *) NULL;
MapPath *MapTEMP;

void RunProgram( char *filename )
{
	WORD key, RetCode;
	int row, col, Chk;
	int X, Y;
	BYTE String[100];
	String[0] = '\0';
	EDITLineFormat InputFormat = { 200, 200, 150, BLUE, WHITE, CYAN, RED };
	InputAPP Designer( &InputFormat, (BYTE *)"͡Ẻ", (BYTE *)"",
					   100, String );
	EDITLineFormat LoadFormat = { 200, 200, 150, BLUE, WHITE, CYAN, RED };
	InputAPP LoadID( &LoadFormat, (BYTE *)"File  Open", (BYTE *)"Filename",
					 100, String );

	ImaCtrl BoxCtrl( 0, 0, 40, 40, 12, 12, BoxIma );
	BoxIma = (MapPtr) NULL;
	if( filename[0] != '\0' )
		MapMAIN = SetMapPath( filename );

	if( MapMAIN )
	{
		MapMAIN->DrawMap();
		BoxCtrl.SwitchOn();
	}
	else
	{
		setfillstyle( SOLID_FILL, RED );
		bar( 480, 0, 639, 479 );
	}

	PositionAPP Position( 0, 0 );

	do {
		if( MapMAIN )
		{
			if( BoxCtrl.Run() )
			{
				BoxCtrl.GetRC( &row, &col );
				Position.Write( row, col );
			}

			if( KeyFlag & LCtrl )
			{
				BoxCtrl.GetRC( &row, &col );
				if( MapMAIN->Add( row, col ) )
				{
					BoxCtrl.SwitchOff();
					MapMAIN->UpdateFloor( row, col );
					MapMAIN->SetChgChk();
					BoxCtrl.SwitchOn();
				}
			}
			else if( KeyFlag & 0X03 )
			{
				BoxCtrl.GetRC( &row, &col );
				if( MapMAIN->Remove( row, col ) )
				{
					BoxCtrl.SwitchOff();
					MapMAIN->UpdateFloor( row, col );
					MapMAIN->SetChgChk();
					BoxCtrl.SwitchOn();
				}
			}

			key = getkeyOnly();
			switch( key ) {
			case 0X3C00 : // F2
				BoxCtrl.SwitchOff();
				MapMAIN->WriteFile();
				BoxCtrl.SwitchOn();
				clrkeyOne();
				key = 0;
				break;

			case 0X2146 : case 0X2166 : // KEY F
				BoxCtrl.GetRC( &row, &col );
				if( MapMAIN->ToggleFinal( row, col ) )
				{
					BoxCtrl.SwitchOff();
					MapMAIN->UpdateFloor( row, col );
					MapMAIN->SetChgChk();
					BoxCtrl.SwitchOn();
				}
				clrkeyOne();
				key = 0;
				break;

			case 0X2044 : case 0X2064 : // KEY D
				BoxCtrl.SwitchOff();
				MapMAIN->GetDesigner( String );
				if( Designer.Input() == 1 )
					MapMAIN->SetDesigner( String );
				BoxCtrl.SwitchOn();
				key = 0;
				break;

			case Esc :
				BoxCtrl.SwitchOff();
				if( !MapMAIN->AskForSave() )
				{
					BoxCtrl.SwitchOn();
					key = 0;
				}
			}

		}
		else
			key = getkeyOnly();

		switch( key ) {
		case 0X3B00 : // F1
			BoxCtrl.SwitchOff();
			HelpView();
			if( MapMAIN )
				BoxCtrl.SwitchOn();
			break;

		case 0X3D00 : // F3
			BoxCtrl.SwitchOff();
			String[0] = '\0';
			LoadID.SetLanguage( 0 );
			if( LoadID.Input() == -1 ) // hit Esc
			{
				if( MapMAIN )
					BoxCtrl.SwitchOn();
				break;
			}

			Chk = 0;
			if( MapMAIN )
			{
				if( MapMAIN->FilenameCmp((char *)String) )
					Chk = 1;
			}
			else
				Chk = 1;

			if( Chk )
			{
				MapTEMP = SetMapPath( (char *)String );
				if( MapTEMP )
				{
					if( MapMAIN )
					{
						if( MapMAIN->AskForSave() )
							delete MapMAIN;  	// Yes, No
						else
							Chk = 0;        	// Cancel
					}
					if( Chk )
					{
						MapMAIN = MapTEMP;
						MapMAIN->DrawMap();
						Position.View();
					}
				}
			}

			BoxCtrl.SwitchOn();
			break;
		}

		ClrkeyOne();
	} while( key != Esc );
	clrkeyAll();
	if( MapMAIN )
		delete MapMAIN;
}

void EndProgram( void )
{
	closegraph();
	if( BoxIma )
		farfree( BoxIma );
	if( CWDrv )
		delete CWDrv;
}

void main( int argc, char *argv[] )
{
	if( !InitialProgram() )
		goto END_MODULE;
	if( argc < 2 )
		RunProgram( "" );
	else
		RunProgram( argv[1] );
	END_MODULE :
	EndProgram();
}

